﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Diagnostics;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;


namespace Test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataTable table = new DataTable();
            table.Columns.Add("Dosage", typeof(int));
            table.Columns.Add("Drug", typeof(bool));
            table.Columns.Add("Patient", typeof(bool));
            table.Columns.Add("Date", typeof(DateTime));

            table.Rows.Add(25, true, true, DateTime.Now);
            table.Rows.Add(50, false, false, DateTime.Now);
            table.Rows.Add(10, true, true, DateTime.Now);
            table.Rows.Add(21, true, true, DateTime.Now);
            table.Rows.Add(100, false, false, DateTime.Now);

            xamDataGrid1.DataSource = table.DefaultView;

        }

        private void xamDataGrid1_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            foreach (var item in (sender as XamDataGrid).Records)
            {
                ItarateGroupRecords(item);
            }
        }

        public void ItarateGroupRecords(Record record)
        {
            if (record is GroupByRecord && !record.Description.Contains("item"))
            {
                if ((record as GroupByRecord).ChildRecords.Count > 1)
                {
                    (record as GroupByRecord).Description += " (" + (record as GroupByRecord).ChildRecords.Count + " items)";
                }
                else
                    (record as GroupByRecord).Description += " (" + (record as GroupByRecord).ChildRecords.Count + " item)";
            }
            else if (record.HasChildren)
            {
                foreach (var item in (record as GroupByRecord).ChildRecords)
                {
                    ItarateGroupRecords(item);
                }
            }                
        }

    }
    public class CustomEvaluator : IGroupByEvaluator
    {
        public bool DoesGroupContainRecord(GroupByRecord groupByRecord, DataRecord record)
        {
            object cellValue = record.GetCellValue(groupByRecord.GroupByField);
            string desc = groupByRecord.Description;

            if (cellValue == null || cellValue is DBNull)
                return false;

            if (cellValue is int == false)
                return true;

            return desc == GetDateLabel((int)cellValue);
        }

        public object GetGroupByValue(GroupByRecord groupByRecord, DataRecord record)
        {
            object cellValue = record.GetCellValue(groupByRecord.GroupByField);
            string desc = string.Empty;
            int targetDate = 0;

            if (cellValue == null || cellValue is DBNull)
            {
                desc = "None";
            }
            else if (cellValue is int)
            {
                targetDate = (int)cellValue;
                desc = GetDateLabel(targetDate);
            }

            groupByRecord.Description = desc; 
            return targetDate;
        }

        public System.Collections.IComparer SortComparer
        {
            get { return null; }
        }

        private string GetDateLabel(int value)
        {
            string desc;

            if (value <= 33)
                desc = "0-33";
            else if (value >33 && value<=66)
                desc = "33-66";
            else
                desc = "66-100";

            return desc;
        }
    }
}
